#include "global.h"

// Taster bý Peter Dannegger


void tasterAlarmzeit(int TASTERPORT, int TASTERBIT)
{
    static unsigned char zustand;
    static unsigned char helper;

    if(zustand == 0 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gedrueckt (steigende Flanke)
    {
        zustand = 1;
    }
    else if (zustand == 1 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gehalten
    {
         zustand = 2;
    }
    else if (zustand == 2 && (TASTERPORT & (1<<TASTERBIT)))   //Taster wird losgelassen (fallende Flanke)
    {
        zustand = 3;

        if (helper == 0) {
            Modus |= MOD_AlarmHour;
            helper=1;
        }
        else if (helper == 1) {
            Modus &= ~(MOD_AlarmHour);
            Modus |= MOD_AlarmMin;
            helper=2;
        }

        else if (helper ==2) {
            deimmAll(15);
            Modus &= ~(MOD_AlarmMin);
            switchfkt();
            Anzeigen(ss,mm,hh,dd,m);
            helper = 0;
        }

    }
    else if (zustand == 3 && (TASTERPORT & (1<<TASTERBIT)))   //Taster losgelassen
    {
        zustand = 0;

    }

}


void tasterX(int TASTERPORT, int TASTERBIT)
{
    static unsigned char zustand;

    if(zustand == 0 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gedrueckt (steigende Flanke)
    {
        zustand = 1;
    }
    else if (zustand == 1 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gehalten
    {
        zustand = 2;

    }
    else if (zustand == 2 && (TASTERPORT & (1<<TASTERBIT)))   //Taster wird losgelassen (fallende Flanke)
    {
        zustand = 3;
//        timeToDS1307(mm, hh);
        timeFromDS1307();
    }
    else if (zustand == 3 && (TASTERPORT & (1<<TASTERBIT)))   //Taster losgelassen
    {
        zustand = 0;
    }

}


void tasterDCFempfang(int TASTERPORT, int TASTERBIT)
{
    static unsigned char zustand;

    if(zustand == 0 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gedrueckt (steigende Flanke)
    {
        zustand = 1;
    }
    else if (zustand == 1 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gehalten
    {
         zustand = 2;
    }
    else if (zustand == 2 && (TASTERPORT & (1<<TASTERBIT)))   //Taster wird losgelassen (fallende Flanke)
    {
        zustand = 3;
        Modus ^= MOD_DCF;
    }
    else if (zustand == 3 && (TASTERPORT & (1<<TASTERBIT)))   //Taster losgelassen
    {
        zustand = 0;
        switchfkt();

    }

}


void tasterSleep(int TASTERPORT, int TASTERBIT)
{
    static unsigned char zustand;

    if(zustand == 0 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gedrueckt (steigende Flanke)
    {
        switchfkt();
        zustand = 1;

    }
    else if (zustand == 1 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gehalten
    {
         zustand = 2;

    }
    else if (zustand == 2 && (TASTERPORT & (1<<TASTERBIT)))   //Taster wird losgelassen (fallende Flanke)
    {
        zustand = 3;
        Modus ^= MOD_Sleep;
    }
    else if (zustand == 3 && (TASTERPORT & (1<<TASTERBIT)))   //Taster losgelassen
    {
        zustand = 0;
        switchfkt();
    }

}

void tasterAlarmEin(int TASTERPORT, int TASTERBIT)
{
    static unsigned char zustand;

    if(zustand == 0 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gedrueckt (steigende Flanke)
    {
        zustand = 1;
        Modus |= MOD_AlarmEin;

    }
    else if (zustand == 1 && !(TASTERPORT & (1<<TASTERBIT)))   //Taster wird gehalten
    {
         zustand = 2;

    }
    else if (zustand == 2 && (TASTERPORT & (1<<TASTERBIT)))   //Taster wird losgelassen (fallende Flanke)
    {
        zustand = 3;

    }
    else if (zustand == 3 && (TASTERPORT & (1<<TASTERBIT)))   //Taster losgelassen
    {
        Modus &= ~MOD_AlarmEin;
        zustand = 0;
        switchfkt();
    }

}

