#include "global.h"


    volatile uint8_t EmmDCF = 0;
    volatile uint8_t ZmmDCF = 0;
    uint8_t EhhDCF = 0;
    uint8_t ZhhDCF = 0;
    volatile uint8_t EmDCF = 0;
    volatile uint8_t ZmDCF = 0;
    volatile uint8_t EdDCF = 0;
    volatile uint8_t ZdDCF = 0;
    volatile uint8_t parM = 0;
    volatile uint8_t parS = 0;
    volatile uint8_t parD = 0;




void DCFzeit(void){
    uint8_t mmDCF = 0;
    uint8_t hhDCF = 0;
    uint8_t dDCF = 0;
    uint8_t mDCF = 0;
    uint8_t yDCF = 0;

    uint8_t EyDCF = 0;
    uint8_t ZyDCF = 0;
    int8_t WochenT = 0;

    EmmDCF = ((dcf[21] * 1) + (dcf[22] * 2) + (dcf[23] * 4) + (dcf[24] * 8));
    ZmmDCF = ((dcf[25] * 1) + (dcf[26] * 2) + (dcf[27] * 4));

    EhhDCF = ((dcf[29] * 1) + (dcf[30] * 2) + (dcf[31] * 4) + (dcf[32] *8));
    ZhhDCF = ((dcf[33] * 1) + (dcf[34] * 2));

    EdDCF =  ((dcf[36] * 1) + (dcf[37] * 2) + (dcf[38] * 4) + (dcf[39] *8));
    ZdDCF =  ((dcf[40] * 1) + (dcf[41] * 2));
    WochenT= ((dcf[42] * 1) + (dcf[43] * 2) + (dcf[44] * 4));
    EmDCF =  ((dcf[45] * 1) + (dcf[46] * 2) + (dcf[47] * 4) + (dcf[48] *8));
    ZmDCF =  ((dcf[49] * 1));
    EyDCF =  ((dcf[50] * 1) + (dcf[51] * 2) + (dcf[52] * 4) + (dcf[53] *8));
    ZyDCF =  ((dcf[54] * 1) + (dcf[55] * 2) + (dcf[56] * 4) + (dcf[57] *8));


    hhDCF = (ZhhDCF*10)+ EhhDCF;
    mmDCF = (ZmmDCF*10)+ EmmDCF;
    dDCF  = (ZdDCF *10)+ EdDCF;
    mDCF  = (ZmDCF *10)+ EmDCF;
    yDCF  = (ZyDCF *10)+ EyDCF;

//    for (int i = 21; i++; i<28){
//        if (dcf[i] == 1) {
//            parM ^= 1;
//        }
//    }
//
//    for (int i = 29; i++; i<35){
//        if (dcf[i] == 1) {
//            parS ^= 1;
//        }
//    }
//
//    for (int i = 36; i++; i<58){
//        if (dcf[i] == 1) {
//            parD ^= 1;
//        }
//    }
//
//    if (dcf[28] == parM &&
//        dcf[35] == parS &&
//        dcf[58] == parD){

            doW = WochenT;
            mm = mmDCF - 1;
            hh = hhDCF;
            dd  = dDCF;
            m  = mDCF;
            y  = yDCF;

//        }


}

volatile uint8_t dcfcounter;
volatile uint16_t pcounter;
volatile uint8_t recieving;
volatile uint8_t dcfbufferposition;
volatile uint16_t dcf[60];
volatile uint8_t cnt;

void DCFempfangen(void) {

    if (( PINA & ( 1 << PA2 )) ) {
            pcounter = 0;
            PORTD |= (1<<PD3);
            dcfcounter++;
        }
    else {
        PORTD &= ~(1<<PD3);
        if (dcfcounter > 70 && dcfcounter < 150) {
                    dcf[dcfbufferposition] = 0;
                    dcfbufferposition++;
        }

        if (dcfcounter > 180 && dcfcounter < 220){
                dcf[dcfbufferposition] = 1;
                dcfbufferposition++;
        }

        dcfcounter = 0;

        if (dcfbufferposition == 59){
            DCFzeit();
            dcfbufferposition = 0;
        }
        pcounter++;
        if (pcounter > 1400){

            pcounter = 0;
            dcfbufferposition = 0;

            ss = 0;
            deimmMaxAus=2;
        }
    }
}

///////////////////////////////////////////////////////////////////////////////////////
////////////////////////////  SICHERER DCF EMPFANG  ///////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////


//volatile uint64_t dcf_bits = 0;     //64Bit Für DCF77-Minute (59 eigentlich nur nötig)
//int8_t dcf77error = 0;
//volatile int16_t dcfIntrCnt = 0;             //zählt die Interrupts, die bei einem DCF-Signal ausgelöst werden
//                                    //bei mir ein Interrupt/ms
//volatile int8_t rx_bit_counter = 0;
//
//struct  DCF77_Bits {
//	unsigned char M			    :1	;
//	unsigned char O1			:1	;
//	unsigned char O2			:1	;
//	unsigned char O3			:1	;
//	unsigned char O4			:1	;
//	unsigned char O5			:1	;
//	unsigned char O6			:1	;
//	unsigned char O7			:1	;
//	unsigned char O8			:1	;
//	unsigned char O9			:1	;
//	unsigned char O10			:1	;
//	unsigned char O11			:1	;
//	unsigned char O12			:1	;
//	unsigned char O13			:1	;
//	unsigned char O14			:1	;
//	unsigned char R			    :1	;
//	unsigned char A1			:1	;
//	unsigned char Z1			:1	;
//	unsigned char Z2			:1	;
//	unsigned char A2			:1	;
//	unsigned char S			    :1	;
//	unsigned char Min			:7	;//7 Bits für die Minuten
//	unsigned char P1			:1	;//Parity Minuten
//	unsigned char Hour			:6	;//6 Bits für die Stunden
//	unsigned char P2			:1	;//Parity Stunden
//	unsigned char Day			:6	;//6 Bits für den Tag
//	unsigned char Weekday		:3	;//3 Bits für den Wochentag
//	unsigned char Month		    :5	;//3 Bits für den Monat
//	unsigned char Year		    :8	;//8 Bits für das Jahr **eine 5 für das Jahr 2005**
//	unsigned char P3			:1	;//Parity von P2
//	} ;
//
//
//struct
//	{
//	volatile char parity_err	:1	;//Hilfs Parity
//	volatile char parity_P1		:1	;//Berechnetes Parity P1
//	volatile char parity_P2		:1	;//Berechnetes Parity P2
//	volatile char parity_P3		:1	;//Berechnetes Parity P3
//	volatile char dcf_rx		:1	;//Es wurde ein Impuls empfangen
//	volatile char dcf_sync		:1	;//In der letzten Minuten wurde die Uhr syncronisiert
//	}flags;
//
//
//struct DCF77_Bits *rx_buffer   //deklariere rx_buffer als Pointer auf struct DCF77_bits (gespeichert in dcf_bits?)
//
//typedef rx_buffer = (struct DCF77_Bits*)(char*)&dcf_rx_buffer;
//
//void DCFempfangenSicher(void) {
//
////59 Bits DCF_Bits
//if (rx_bit_counter == 59 &&
//    flags.parity_P1 == (*rx_buffer).P1 &&
//    flags.parity_P2 == (*rx_buffer).P2 &&
//    flags.parity_P3 == (*rx_buffer).P3){
//
//
//
////      Uhrzeit aus DCF (BCD) in Decimal
//        mm  =  BCD2Dec((*rx_buffer).Min);
//        hh  =  BCD2Dec((*rx_buffer).Hour);
//        dd  =  BCD2Dec((*rx_buffer).Day);
//        doW =  BCD2Dec((*rx_buffer).Weekday);
//        m   =  BCD2Dec((*rx_buffer).Month);
//        y   =  BCD2Dec((*rx_buffer).Year);
//
//        ss = 59;
//        flags.dcf_sync = 1;
//
//    }
//    else {
//        flags.dcf_sync = 0;
//    }
//
//}
//
//void DCFempfangSicherAuslesen(void) {
//
//    if ( PINA & ( 1 << PA2 )) {
//        dcfIntrCnt++;
//        }
//    else {
//        //Parität speichern
//        //beginn von Bereich P1/P2/P3
//        if (rx_bit_counter ==  21 || rx_bit_counter ==  29 || rx_bit_counter ==  36)
//         {
//         flags.parity_err = 0;
//         };
//        //Speichern von P1
//        if (rx_bit_counter ==  28) {flags.parity_P1 = flags.parity_err;};
//        //Speichern von P2
//        if (rx_bit_counter ==  35) {flags.parity_P2 = flags.parity_err;};
//        //Speichern vo
//        if (rx_bit_counter ==  58) {flags.parity_P3 = flags.parity_err;};
//        //dcfIntrCnt größer als 150ms
//        if (dcfIntrCnt > 150){
//            //Schreibe 1 in rx_buffer an der Bitstelle dcf_bits
//            dcf_bits = dcf_bits | ((uint64_t) 1 << rx_bit_counter);
//            //Toogle Hilfs Parity
//
//        }
//        //950 ms vorbei, keine DCF eingefangen
//        flags.parity_err = flags.parity_err ^ 1;
//        rx_bit_counter++;
//    }
//}




