#include "global.h"

char BCD2Dec(char Wert)
{
   return (Wert%16 + 10 * (Wert/16));
}



void timeToDS1307(char min, char stunde){

    i2c_init();
    i2c_start_wait(DS1307_I2C_ADDRESS + I2C_WRITE);
    i2c_write(0x00);
    i2c_write((int8_t)((ss/10<<4)+(ss%10)));
    i2c_write((int8_t)((min/10<<4)+(min%10)));
    i2c_write((int8_t)((stunde/10<<4)+(stunde%10)));
    i2c_write((int8_t)(doW));
    i2c_write((int8_t)((dd/10<<4)+(dd%10)));
    i2c_write((int8_t)((m/10<<4)+(m%10)));
    i2c_write((int8_t)((y/10<<4)+(y%10)));
    i2c_write(0x13);
    i2c_stop();

}


void timeFromDS1307(void){


    i2c_init();
    i2c_start_wait((DS1307_I2C_ADDRESS + I2C_WRITE));
    i2c_write(0x00);
    i2c_rep_start(DS1307_I2C_ADDRESS + I2C_READ);
    ss = BCD2Dec(i2c_readAck());
    mm = BCD2Dec(i2c_readAck());
    hh = BCD2Dec(i2c_readAck());
    doW= BCD2Dec(i2c_readAck());
    dd = BCD2Dec(i2c_readAck());
    m  = BCD2Dec(i2c_readAck());
    y  = BCD2Dec(i2c_readAck());
    i2c_readNak();
    i2c_stop();

}
