#include "global.h"



// Zähler
void Uhrzeit () {

    UhrzeitUeberlauf();

}

//Wecker
void Weckzeit () {

    if (mmW > 59) {mmW = 0;  hhW++;}
    if (mmW < 0 ) {mmW = 59; hhW--;}
    if (hhW > 23) {hhW = 0;}
    if (hhW < 0 ) {hhW = 23;}

    UhrzeitUeberlauf();

    Anzeigen (ss, mmW, hhW, 77, 77);
}

void switchfkt(void){
      switch (Modus)
        {
        case 0b00000000:
        {
            DCFempfang = 0;
            AlarmEin = 0;
            Alarmzeit = 0;

            deimmAll(15);
            Uhrzeit();

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Sleep
        case 0b00000001:
        {
            AlarmEin = 0;
            DCFempfang  = 0;
            Alarmzeit = 0;

            deimmAll(1);
            Uhrzeit();

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Alarm ein
        case 0b00000010:
        {
            Alarmzeit = 0;
            AlarmEin = 1;
            DCFempfang  = 0;

            deimmAll(15);
            Uhrzeit();

            PORTD |= (1<<PD0) | (1<<PD1);
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        case 0b00000011:
        //Sleep + Alarm
        {
            Alarmzeit = 0;
            AlarmEin = 1;
            DCFempfang  = 0;

            deimmAll(1);
            Uhrzeit();

            PORTD |= (1<<PD1);
            PORTD &= ~(1<<PD0);
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //DCF
        case 0b00000100:
        {
            Alarmzeit = 0;
            AlarmEin = 0;
            DCFempfang  = 1;

            Uhrzeit();
            deimmAll(15);

            PORTD |= (1<<PD2);
            PORTD &= ~((1<<PD0) | (1<<PD1));
            break;
        }
        //DCF + Alarm
        case 0b00000110:
        {
            Alarmzeit = 0;
            AlarmEin = 1;
            DCFempfang  = 1;

            Uhrzeit();
            deimmAll(15);

            PORTD |= (1<<PD2);
            PORTD |= (1<<PD0) | (1<<PD1);
            break;
        }
        //DCF + Sleep
        case 0b00000101:
        {
            Alarmzeit = 0;
            AlarmEin = 0;
            DCFempfang  = 1;

            Uhrzeit();
            deimmAll(1);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD |= (1<<PD2);
            break;
        }
        //DCF + Alarm + Sleep
        case 0b00000111:
        {
            DCFempfang = 1;
            Alarmzeit = 0;
            AlarmEin = 1;

            Uhrzeit();
            deimmAll(1);

            PORTD |= (1<<PD1);
            PORTD &= ~(1<<PD0);
            PORTD |= (1<<PD2);
            break;
        }
        // Weckzeit  hh einstellen
        case 0b00001000:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm einstellen
        case 0b00010000:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Sleep
        case 0b00001001:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm + Sleep
        case 0b00010001:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Alarm
        case 0b00001010:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm + Alarm
        case 0b00010010:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Alarm + Sleep
        case 0b00001011:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm + Alarm + Sleep
        case 0b00010011:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD &= ~((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + DCF
        case 0b00001100:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm + DCF
        case 0b00010100:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Alarm + DCF
        case 0b00001110:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm + Alarm + DCF
        case 0b00010110:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Alarm + Sleep + DCF
        case 0b00001111:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit mm + Alarm + Sleep + DCF
        case 0b00010111:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD |= ((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Sleep + DCF
        case 0b00001101:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            hhW += encode_read1();
            Weckzeit();
            deimm(15,1);
            deimm(1,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
        //Weckzeit hh + Sleep + DCF
        case 0b00010101:
        {
            AlarmEin = 0;
            DCFempfang = 0;
            Alarmzeit = 1;

            mmW += encode_read1();
            Weckzeit();
            deimm(1,1);
            deimm(15,2);
            deimm(1,3);

            PORTD &= ~((1<<PD0) | (1<<PD1));
            PORTD |= ((1<<PD2) | (1<<PD3));
            break;
        }
//        //Nacht
//        case 0b00100000:
//        {
//            AlarmEin = 0;
//            DCFempfang = 0;
//            Alarmzeit = 0;
//
//            Uhrzeit();
//            deimmAllAus();
//
//            PORTD &= ~((1<<PD0) | (1<<PD1));
//            PORTD &= ~((1<<PD2) | (1<<PD3));
//            break;
//        }
//        //Nacht + Sleep //nicht möglich
//        case 0b00100001:
//        {
//            AlarmEin = 0;
//            DCFempfang = 0;
//            Alarmzeit = 0;
//
//            Uhrzeit();
//            deimmAllAus();
//
//            PORTD &= ~((1<<PD0) | (1<<PD1));
//            PORTD &= ~((1<<PD2) | (1<<PD3));
//            break;
//        }
//        //Nacht + AlarmEin
//        case 0b001000010:
//        {
//            AlarmEin = 1;
//            DCFempfang = 0;
//            Alarmzeit = 0;
//
//            Uhrzeit();
//            deimmAllAus();
//
//            PORTD |= (1<<PD1);
//            PORTD &= ~(1<<PD0);
//            PORTD &= ~((1<<PD2) | (1<<PD3));
//            deimmAllAus();
//            break;
//        }
//        //Nacht + Sleep + Alarm //nicht möglich
//        case 0b001000011:
//        {
//            AlarmEin = 1;
//            DCFempfang = 0;
//            Alarmzeit = 0;
//
//            Uhrzeit();
//            deimmAllAus();
//
//            PORTD |= (1<<PD1);
//            PORTD &= ~(1<<PD0);
//            PORTD &= ~((1<<PD2) | (1<<PD3));
//            break;
//        }
//        //Nacht + DCF
//        case 0b001000100:
//        {
//            AlarmEin = 0;
//            DCFempfang = 1;
//            Alarmzeit = 0;
//
//            Uhrzeit();
//            deimmAllAus();
//
//            PORTD &= ~((1<<PD0) | (1<<PD1));
//            PORTD &= ~((1<<PD2) | (1<<PD3));
//            break;
//        }
//        //Nacht + DCF + Sleep
//        case 0b001000101:
//        {
//            AlarmEin = 0;
//            DCFempfang = 0;
//            Alarmzeit = 0;
//
//            Uhrzeit();
//            deimmAllAus();
//
//            PORTD &= ~((1<<PD0) | (1<<PD1));
//            PORTD &= ~((1<<PD2) | (1<<PD3));
//            break;
//
//        }
        //Nacht +

    }

}
