#include "global.h"

volatile int8_t enc_delta;
int8_t last;
volatile int8_t val;

void long_delay(uint16_t ms)
{
    for (; ms>0; ms--) _delay_ms(1);
}


int8_t encode_read1(void)         // read single step encoders
{
  int8_t val;

  cli();
  val = enc_delta;
  enc_delta = val & 1;
  sei();
  return val >> 1;
}
